/*
   // This header file creates a menu
   // Use the following code to create a menu

# include <iostream.h>
# include <conio.h>
# include <dos.h>
# include <stdio.h>
# include <string.h>
# include <c:\ankur\cpp_pro\general.h>
# include <c:\ankur\cpp_pro\menu.h>

main()
 {
   box a;                        // declare object a
   strcpy(a.item[0],"first");    // first  item of the menu
   strcpy(a.item[1],"second");   // second item of the menu
   strcpy(a.item[2],"third");    // third  item of the menu
   strcpy(a.item[3],"fourth");   // fourth item of the menu

   a.hotkey[0] = 0;		 // these lines initialise the hotkeys to
   a.hotkey[1] = 0;              // f for first , s for second ,t for third
   a.hotkey[2] = 0;              // and o for fourth
   a.hotkey[3] = 1;              //

   int y = a.menu(7,6);          // invoke menu (starting column , starting row)
				 // y stores the value of the item chosen
				 // Here, y=1 if item[0] was selected
				 //       y=2 if item[1] was selected
				 //    and so on
 }
   // The menu in this case will be displayed in the 7th column and 6th row
   // and will look like this :
//
//              ͻ
//               first  
//               second 
//               third  
//               fourth 
//              ͼ
   // y will contain the appropriate value of the item which you select
   // using the up and down arrow keys and enter
*/

class box   {
		private : int c1,c2,r1,r2,no_of_items,max_length;
		public  : int y,hotkey[23];
			  char item[23][23];

		public : int  menu(int,int,char);
			 void display(void);
			 int cursor();
			 void overwrite(int);
			 box()
			   {
			      y=1;
			      for(int i=0;i<23;i++)
				{
				   strcpy(item[i],NULL);
				   hotkey[i] = 0;
				}
			   }
			~box() {}

		};

void box :: overwrite(int no)
   {
     cprintf("%s",item[no-1]);
     int j = max_length - strlen(item[no-1]);
     for (int i=0;i<j;i++)
       cputs(" ");
     textcolor(BROWN);
     gotoxy(c1+hotkey[no-1]+1,no+r1-1);
     cprintf("%c",item[no-1][hotkey[no-1]]);
     textcolor(WHITE);
     textbackground(BLACK);
     gotoxy(c1,no+r1-1);
   }

int box :: menu(int c,int r,char s = 'n')
  {
  textcolor(WHITE);
  textbackground(BLACK);
  max_length = maxlen(item);
  no_of_items = tot_items(item);
  c1=c+1;
  r1=r+1;
  c2 = c + max_length + 2;
  r2 = r + no_of_items;
  if (s=='s')
    shade(c1-1,r1-1,c2+1,r2+1);
  textcolor(WHITE);
  textbackground(BLACK);
  draw(c1-1,r1-1,c2+1,r2+1);
  display();
  int y = cursor();

  textcolor(WHITE);
  textbackground(BLACK);

  return(y);
  }

void box :: display(void)
    {
    gotoxy(c1,r1);
    textcolor(WHITE);
    for (int i=1;i<=no_of_items;i++)
	{
	  cputs(" ");
	  overwrite(i);
	  gotoxy(c2,r1+i-1);
	  cputs(" ");
//	  if (i!=no_of_items)
	     gotoxy(c1,r1+i);
	}

    gotoxy(c1+1,y+r1-1);
//    cputs(" ");
    textcolor(BLACK);
    textbackground(BLUE);
    overwrite(y);
    gotoxy(c1,r1+y-1);
//    cputs("\r");
    }

box :: cursor(void)
   {
    key key1;
    while(1)
      {
      key1 = getkey();
      if(key1.ascii==13)      //enter
	 return(y);
      else
       {
	textcolor(WHITE);
	textbackground(BLACK);
	cputs(" ");
	overwrite(y);

	switch(key1.scan)
	  {
	   case 72 :                       //up
			{
			  if (y==1)
			     y=no_of_items;
			  else
			     y--;
			  break;
			}

	   case 80 :                       //down
			{
			  if (y==no_of_items)
			     y=1;
			  else
			     y++;
			  break;
			}

	   default :                       // other keys
			{
			  int alternate,flag = 0;
			  if (key1.ascii >= 97 && key1.ascii <= 122)
			       alternate = key1.ascii - 32;
			  else if (key1.ascii >= 65 && key1.ascii <= 90)
			       alternate = key1.ascii + 32;
			  for(int i=0;i < no_of_items;i++)
			    {
			      if (item[i][hotkey[i]] == key1.ascii ||
					 item[i][hotkey[i]] == alternate)
				{
				   y = i + 1;
				   flag = 1;
	   gotoxy(c1,r1+y-1);
	   cputs(" ");
	   textcolor(BLACK);
	   textbackground(BLUE);
	   overwrite(y);
	   return(y);
				}
			    }
			  if (flag == 0)
			    cputs("\a");
			  break;
			}
	  }

	   gotoxy(c1,r1+y-1);
	   cputs(" ");
	   textcolor(BLACK);
	   textbackground(BLUE);
	   overwrite(y);
       }
      }
   }
